/* Example: building a complicated data structure, step by step */

#include <stdio.h>

/* declare structures: */

struct date {
              int d;  /* day of month, 1 to 31 */
              int m;  /* month, 1 to 12 */
              int y;  /* year, e.g. 1996 - avoids millenium bug! */
            };

struct module {
                unsigned int pc;  /* percentage mark, 0 to 100 */
                char gr;          /* letter grade, S to F */
                unsigned int cr;  /* credits awarded */
              };

struct student {
                 long urn;             /* University Reg. No. */
                 char surname[20];     /* surname */
                 char forenames[30];   /* forenames */
                 struct date born;     /* date of birth */
                 struct date enrol;    /* date of enrolment */
                 struct module L1U10;  /* programming module */
               };


void print_results(struct student s);  /* function prototype */


void main(void)
{
  /* declare and initialise structured variables: */
  
  struct student him = {1234567, "JOHNSON", "Jeremiah Methuselah", 
                        {27, 3, 1974}, {3, 9, 1995}, {0, '\0', 0,}
                       };
  
  struct student her = {5342096, "ROBINSON", "Anne Louise", 
                        {5, 11, 1978}, {1, 9, 1996}, {0, '\0', 0,}
                       };

  /* assign values to structure members: */
    
  him.L1U10.pc = 23; him.L1U10.gr = 'F'; him.L1U10.cr = 0; 
  her.L1U10.pc = 89; her.L1U10.gr = 'S'; her.L1U10.cr = 10; 
  
  /* call a function, passing structure as argument: */
  
  print_results(him);
  print_results(her);
  return;
}


void print_results(struct student s)
{
  printf("URN: %li -- ", s.urn);
  printf("%s %s\n", s.forenames, s.surname);
  printf("  Born:     %i/%i/%i\n", s.born.d, s.born.m, s.born.y);
  printf("  Enrolled: %i/%i/%i\n", s.enrol.d, s.enrol.m, s.enrol.y);
  printf("  Module L1U10: %i%%, ", s.L1U10.pc);
  printf("grade %c, ", s.L1U10.gr);
  printf("%i credits\n\n", s.L1U10.cr);
  return;
}
